
*******************************************
**  INCLUDE:  _Library.ch
**
**  WRITER:   Mark Mitchelson
**  SUMMARY:  My Favorite Translations.
**
**            I wanted to share these before I translated them to
**            functions for use in VO.
**
**  These are original works by Mark Mitchelson and placed in public domain.
*******************************************




////////////////////////////  STANDARD DEFINES  ///////////////////////////////
#define CRLF  Chr(13)+Chr(10)
#define B_THICK ""
#define B_FAT   ""


//  Repeat Until loop
//  - This does atleast one loop
//
//  i.e.  x := 9           -> Loop twice
//        Repeat
//           ? x++
//        Until x > 10
#command Repeat => do while .T.
#command Until <lCond> => if(<lCond>); exit ; end ; end



////////////////////////////  COMMAND DEFINES  ///////////////////////////////


//  Return if this var is empty  (10/13/93)
//
//  - if a string it must be = ''
//
//  i.e. EMPTY("  ")   --> .T.
//       cEMPTY("  ")  --> .F.
//       cEMPTY("")    --> .T.
////////////////////////////////////////////////////////////////////
#translate  cEmpty( <str> ) ;
             => ;
             iif( valtype( <str> ) = 'C', <str> == '', Empty( <str> ) )


//  Display a character to the screen at the current cusror location wihthout
//  disturbing the current screen atributes.  (11/31/93)
//
//  - i.e.  - (FRAME A TITLE IN COLORS OF THE BOX)
//          SetColor("B/W")
//          Box( 0,0,25,79, B_DOUBLE )
//          SetPos( 0,60 )
//          cDispOut("")     --> Output using exising screen colors
//          DispOut("Title", "R/W")
//          SetPos( 0,67 )
//          cDispOut("")     --> Output using exising screen colors
//
/////////////////////////////////////////////////////////////////////////////
#translate cDispOut( <cChar> ) ;
            => ;
            RestScreen( Row(), Col(), Row(), Col(), ;
                        <cChar> + Right(SaveScreen( Row(), Col(), Row(), Col()), 1 )) ;
            ; SetPos( Row(), Col()+1 )


//  Evaluate the code block and return the value - ARRAY OF CODE BLOCKS
//  Value : NIL return [.T.]
//        : Code block - return the value
//        : Array of code blocks - return the value of the last code block
//////////////////////////////////////////////////////////////////////////
//#xTranslate uEval( <u>[, <para1>[, <para2>[, <para3>]]] ) ;
//            => ;
//            ( <u> = NIL ;
//              .or. iif( ValType(<u>) = 'B', ;
//                      Eval( <u>, <para1>, <para2>, <para3> ), ;
//                      ( aEval( <u>, {|a| Eval( a, <para1>, <para2>, <para3> ) }, 1, Len(<u>)-1 ), ;
//                        ; //  Return the value of the last block
//                        Eval( aTail(<u>), <para1>, <para2>, <para3> ) ;
//                      ) ;
//                    ) ;
//            )


//  Character tests  (08/31/93)
#translate IsAlpha(<val>) => ( 'A' <= <val> .and. <val> <= 'z' .or. <val> = ' ' )
#translate IsPunct(<val>) => ( '!' <= <val> .and. <val> <= '/' .or. <val> = '/' .or. ':' <= <val> .and. <val> <= '@' .or. '[' <= <val> .and. <val> <= "'" .or. '{' <= <val> .and. <val> <= '~'  )
#translate IsNum(<val>) => ( '0' <= <val> .and. <val> <= '9' )


//  Test if a number is even  (06/20/93)
//
//  - i.e., IsEven(123) => .F., IsEven(122) => .T., IsEven(0) => .T.
#translate IsEven( <ival> ) ;
            => ;
            ((<ival> % 2) = 0)

//  Test if a number is a multiplier of another (08/01/93)
//
//  - i.e., IsMultiplier(10,2) => .T., IsMultiplier(11,2) => .F.
#translate IsMultiplier( <ival>, <imult> ) ;
            => ;
            ((<ival> % <imult>) = 0)

//  Day Of Year (06/20/93)
//
//  - Determine how many days have pass in the current year starting with
//    New Year's Day of the same year as the date parameter.
//
//  - i.e., DOY( ctod("01/03/xx")) => 3, DOY( ctod("01/01/xx")) => 1
//
#translate DOY( <date> ) ;
            => ;
            ( <date> - ctod("01/01/" + Right(Str(Year( <date> ),4),2) ) + 1 )

//  Day Of Year (06/20/93)
//
//  - Determine the day of the year based on a calendar starting week day.
//    This is the number of days past 01/01/xx offset by the day of the
//    week New Year's day was on.
//
//  - i.e., DOY( 01/03/93, 5)) => 3, DOY( 01/01/93, 1 ) => 5
//
//  INPUT:  <istart_day> - 0Sunday, ..., 6Saturday
#translate DOY( <date>, <istart_day> ) ;
            => ;
            ( <date> ;
              - ctod("01/01/" + Right(Str(Year( <date> ),4),2)) ;
              + DOW( ctod("01/01/" + Right(Str(Year( <date> ),4),2)) ) ;
              - <istart_day> )

//  Week of Year (06/20/93)
//
//  - Determine how many weeks have pass in the current year starting with
//    New Year's Day.
//
//  - i.e., WOY( 01/03/93 ) => 1,  WOY( 01/14/93 ) => 2
#translate WoY( <date> [, <istart_day>] ) ;
            => ;
            Int( (DOY(<date> [, <istart_day>] ) + 6) / 7 )


//  Method to save/restore screen with corrds built in  (02/29/93)
//////////////////////////////////////////////////////////////////
#translate ScrSave( <top>, <left>, <bottom>, <right> ) ;
            => ;
            { <top>, <left>, <bottom>, <right>, ;
              SaveScreen( <top>, <left>, <bottom>, <right> ) ;
            }
#translate ScrRestore( <aScr> ) ;
            => ;
            RestScreen( <aScr>\[1\], <aScr>\[2\], <aScr>\[3\], <aScr>\[4\], ;
                        <aScr>\[5\] )

            //  Restore to a different location
            //  - assume that the restoration will fit in window
#translate ScrRestore( <aScr>, <it>, <il> ) ;
            => ;
            RestScreen( <it>, <il>, <it>+<aScr>\[3\]-<aScr>\[1\], <il>+<aScr>\[4\]-<aScr>\[2\], ;
                        <aScr>\[5\] )

//  Cursor Stats Save  (02/29/93)
//////////////////////////////////////////////////////////////
//#translate CursorOn() => SetCursor( iif( Set(_SET_INSERT), 2, 1 ))
#translate CursorOff() => SetCursor( 0 )

#translate CursorSave([ <uCursor_Mode> ]) ;
            => ;
            { Row(), Col(), SetCursor(<uCursor_Mode>) ;
            }
#translate CursorRestore( <aCursor> ) ;
            => ;
            SetPos( <aCursor>\[1\], <aCursor>\[2\] ) ; ;
            SetCursor( <aCursor>\[3\] )


//  Count the # of <cSearch> occurances in <cString>  (12/26/92)
////////////////////////////////////////////////////////////////
#translate StrCount( <cSearch>, <cString> ) ;
            => ;
            ( Len( <cString> ) - Len( StrTran( <cString>, <cSearch>, "" )))


//  end  //
